#include "flatplate.h"

int main(int argc, char **argv)
{
	int ncpu = 16;
	int Nx = 401, Ny=401;
        long int Nt=32001;
	int ii, jj, kk, nc;
	double Lx1 = -0.5, Lx2 = 1.5, Ly=5, Tmax=1;
	struct State S;

	double *time;
	double *f;
	double *grad1, *grad2, *grad3, *grad;
	double dt;
	double tmp;

	double *d, *dl, *du, *diags;
	double eps = 3;
	// FILE *fp;
	// hid_t fileid;
	struct Snap snap;
	int ncheck;
	int isnap;
	int save2disk=1;


	// printf("argc = %d\n", argc);
	if(argc>1) 
	{
		printf("File: %s\n", argv[1]);
		snap.fileid = h5file(argv[1]);
	}
	else snap.fileid = h5file("snaps.hdf5");
	if(snap.fileid<=0)
	{
		printf("Invalid file or file does not exist. Quitting.\n");
		return 1;
	}
	S = state_from_hdf5(snap.fileid);
	
	Ny = S.Ny; Nx = S.Nx;

	snap.n1 = read_attr_int(snap.fileid, "n1");
	snap.n2 = read_attr_int(snap.fileid, "n2");
	ncheck = snap.n1 + snap.n2;
	snap.idcheck = (int*)   malloc(ncheck*sizeof(int));
	snap.ilast = (int*) malloc(sizeof(int));
	snap.ucheck = (double*) malloc(ncheck*(Nx*(Ny-1) + Ny*(Nx-1))*sizeof(double));

	if (snap.ucheck == NULL) 
	{
		printf("Memory for checks: %f MB, too much. Saving to disk ...\n", 
				((double)ncheck)*(Nx*(Ny-1) + Ny*(Nx-1))/(1024*1024));
		return -2;
	}
	else 
	{
		printf("Using checks memory: %f MB\n", ((double)ncheck)*8*(Nx*(Ny-1) + Ny*(Nx-1))/(1024*1024)); 
		snap.vcheck = snap.ucheck + ncheck*Nx*(Ny-1);
		snap.ilast[0] = -1; // There are no checkpoints to begin with
	}

	// Now we need to read S.x, S.y, time and f from fileid
	state_readgrid(snap.fileid, S);
	for(ii=0;ii<Nx-1;ii++) S.xh[ii] = 0.5*(S.x[ii]+S.x[ii+1]);
	for(jj=0;jj<Ny-1;jj++) S.yh[jj] = 0.5*(S.y[jj]+S.y[jj+1]);

	traverse(S, snap, save2disk);
	state_writef(snap.fileid, S);

	H5Fclose(snap.fileid);
	return 0;
}

